chiark / gitweb /
Merge commit 'refs/top-bases/fixes/independent-help' into fixes/independent-help
[topgit.git] / tg.sh
1 #!/bin/sh
2 # TopGit - A different patch queue manager
3 # (c) Petr Baudis <pasky@suse.cz>  2008
4 # GPLv2
5
6 TG_VERSION=0.6
7
8 ## Auxiliary functions
9
10 info()
11 {
12         echo "${TG_RECURSIVE}tg: $*"
13 }
14
15 die()
16 {
17         info "fatal: $*"
18         exit 1
19 }
20
21 # cat_file "topic:file"
22 # Like `git cat-file blob $1`, but topics '(i)' and '(w)' means index and worktree
23 cat_file()
24 {
25         arg="$1"
26         case "$arg" in
27         '(w):'*)
28                 arg=$(echo "$arg" | tail --bytes=+5)
29                 cat "$arg"
30                 return
31                 ;;
32         '(i):'*)
33                 # ':file' means cat from index
34                 arg=$(echo "$arg" | tail --bytes=+5)
35                 git cat-file blob ":$arg"
36                 ;;
37         *)
38                 git cat-file blob "$arg"
39         esac
40 }
41
42 # setup_hook NAME
43 setup_hook()
44 {
45         hook_call="\"\$($tg --hooks-path)\"/$1 \"\$@\""
46         if [ -f "$git_dir/hooks/$1" ] &&
47            fgrep -q "$hook_call" "$git_dir/hooks/$1"; then
48                 # Another job well done!
49                 return
50         fi
51         # Prepare incantation
52         if [ -x "$git_dir/hooks/$1" ]; then
53                 hook_call="$hook_call"' || exit $?'
54         else
55                 hook_call="exec $hook_call"
56         fi
57         # Insert call into the hook
58         {
59                 echo "#!/bin/sh"
60                 echo "$hook_call"
61                 [ ! -s "$git_dir/hooks/$1" ] || cat "$git_dir/hooks/$1"
62         } >"$git_dir/hooks/$1+"
63         chmod a+x "$git_dir/hooks/$1+"
64         mv "$git_dir/hooks/$1+" "$git_dir/hooks/$1"
65 }
66
67 # setup_ours (no arguments)
68 setup_ours()
69 {
70         if [ ! -s "$git_dir/info/attributes" ] || ! grep -q topmsg "$git_dir/info/attributes"; then
71                 {
72                         echo ".topmsg   merge=ours"
73                         echo ".topdeps  merge=ours"
74                 } >>"$git_dir/info/attributes"
75         fi
76         if ! git config merge.ours.driver >/dev/null; then
77                 git config merge.ours.name '"always keep ours" merge driver'
78                 git config merge.ours.driver 'touch %A'
79         fi
80 }
81
82 # measure_branch NAME [BASE]
83 measure_branch()
84 {
85         _bname="$1"; _base="$2"
86         [ -n "$_base" ] || _base="refs/top-bases/$_bname"
87         # The caller should've verified $name is valid
88         _commits="$(git rev-list "$_bname" ^"$_base" -- | wc -l)"
89         _nmcommits="$(git rev-list --no-merges "$_bname" ^"$_base" -- | wc -l)"
90         if [ $_commits -gt 1 ]; then
91                 _suffix="commits"
92         else
93                 _suffix="commit"
94         fi
95         echo "$_commits/$_nmcommits $_suffix"
96 }
97
98 # branch_contains B1 B2
99 # Whether B1 is a superset of B2.
100 branch_contains()
101 {
102         [ -z "$(git rev-list --max-count=1 ^"$1" "$2" --)" ]
103 }
104
105 # ref_exists REF
106 # Whether REF is a valid ref name
107 ref_exists()
108 {
109         git rev-parse --verify "$@" >/dev/null 2>&1
110 }
111
112 # has_remote BRANCH
113 # Whether BRANCH has a remote equivalent (accepts top-bases/ too)
114 has_remote()
115 {
116         [ -n "$base_remote" ] && ref_exists "remotes/$base_remote/$1"
117 }
118
119 branch_annihilated()
120 {
121         _name="$1";
122
123         # use the merge base in case the base is ahead.
124         mb="$(git merge-base "refs/top-bases/$_name" "$_name")";
125
126         test "$(git rev-parse "$mb^{tree}")" = "$(git rev-parse "$_name^{tree}")";
127 }
128
129 # recurse_deps CMD NAME [BRANCHPATH...]
130 # Recursively eval CMD on all dependencies of NAME.
131 # CMD can refer to $_name for queried branch name,
132 # $_dep for dependency name,
133 # $_depchain for space-seperated branch backtrace,
134 # and the $_dep_is_tgish boolean.
135 # It can modify $_ret to affect the return value
136 # of the whole function.
137 # If recurse_deps() hits missing dependencies, it will append
138 # them to space-separated $missing_deps list and skip them.
139 recurse_deps()
140 {
141         _cmd="$1"; shift
142         _name="$1"; # no shift
143         _depchain="$*"
144
145         _depsfile="$(mktemp -t tg-depsfile.XXXXXX)"
146         # Check also our base against remote base. Checking our head
147         # against remote head has to be done in the helper.
148         if has_remote "top-bases/$_name"; then
149                 echo "refs/remotes/$base_remote/top-bases/$_name" >>"$_depsfile"
150         fi
151
152         # if the branch was annihilated, there exists no .topdeps file
153         if ! branch_annihilated "$_name"; then
154                 #TODO: handle nonexisting .topdeps?
155                 git cat-file blob "$_name:.topdeps" >>"$_depsfile";
156         fi;
157
158         _ret=0
159         while read _dep; do
160                 if ! ref_exists "$_dep" ; then
161                         # All hope is lost
162                         missing_deps="$missing_deps $_dep"
163                         continue
164                 fi
165
166                 _dep_is_tgish=1
167                 ref_exists "refs/top-bases/$_dep"  ||
168                         _dep_is_tgish=
169
170                 # Shoo shoo, keep our environment alone!
171                 [ -z "$_dep_is_tgish" ] ||
172                         (recurse_deps "$_cmd" "$_dep" "$@") ||
173                         _ret=$?
174
175                 eval "$_cmd"
176         done <"$_depsfile"
177         missing_deps="${missing_deps# }"
178         rm "$_depsfile"
179         return $_ret
180 }
181
182 # branch_needs_update
183 # This is a helper function for determining whether given branch
184 # is up-to-date wrt. its dependencies. It expects input as if it
185 # is called as a recurse_deps() helper.
186 # In case the branch does need update, it will echo it together
187 # with the branch backtrace on the output (see needs_update()
188 # description for details) and set $_ret to non-zero.
189 branch_needs_update()
190 {
191         _dep_base_update=
192         if [ -n "$_dep_is_tgish" ]; then
193                 if has_remote "$_dep"; then
194                         branch_contains "$_dep" "refs/remotes/$base_remote/$_dep" || _dep_base_update=%
195                 fi
196                 # This can possibly override the remote check result;
197                 # we want to sync with our base first
198                 branch_contains "$_dep" "refs/top-bases/$_dep" || _dep_base_update=:
199         fi
200
201         if [ -n "$_dep_base_update" ]; then
202                 # _dep needs to be synced with its base/remote
203                 echo "$_dep_base_update $_dep $_depchain"
204                 _ret=1
205         elif [ -n "$_name" ] && ! branch_contains "refs/top-bases/$_name" "$_dep"; then
206                 # Some new commits in _dep
207                 echo "$_dep $_depchain"
208                 _ret=1
209         fi
210 }
211
212 # needs_update NAME
213 # This function is recursive; it outputs reverse path from NAME
214 # to the branch (e.g. B_DIRTY B1 B2 NAME), one path per line,
215 # inner paths first. Innermost name can be ':' if the head is
216 # not in sync with the base or '%' if the head is not in sync
217 # with the remote (in this order of priority).
218 # It will also return non-zero status if NAME needs update.
219 # If needs_update() hits missing dependencies, it will append
220 # them to space-separated $missing_deps list and skip them.
221 needs_update()
222 {
223         recurse_deps branch_needs_update "$@"
224 }
225
226 # branch_empty NAME
227 branch_empty()
228 {
229         [ -z "$(git diff-tree "refs/top-bases/$1" "$1" | fgrep -v "     .top")" ]
230 }
231
232 # switch_to_base NAME [SEED]
233 switch_to_base()
234 {
235         _base="refs/top-bases/$1"; _seed="$2"
236         # We have to do all the hard work ourselves :/
237         # This is like git checkout -b "$_base" "$_seed"
238         # (or just git checkout "$_base"),
239         # but does not create a detached HEAD.
240         git read-tree -u -m HEAD "${_seed:-$_base}"
241         [ -z "$_seed" ] || git update-ref "$_base" "$_seed"
242         git symbolic-ref HEAD "$_base"
243 }
244
245 # Show the help messages.
246 do_help()
247 {
248         if [ -z "$1" ] ; then
249                 # This is currently invoked in all kinds of circumstances,
250                 # including when the user made a usage error. Should we end up
251                 # providing more than a short help message, then we should
252                 # differentiate.
253                 # Petr's comment: http://marc.info/?l=git&m=122718711327376&w=2
254
255                 ## Build available commands list for help output
256
257                 cmds=
258                 sep=
259                 for cmd in "@cmddir@"/tg-*; do
260                         ! [ -r "$cmd" ] && continue
261                         # strip directory part and "tg-" prefix
262                         cmd="$(basename "$cmd")"
263                         cmd="${cmd#tg-}"
264                         cmds="$cmds$sep$cmd"
265                         sep="|"
266                 done
267
268                 echo "TopGit v$TG_VERSION - A different patch queue manager"
269                 echo "Usage: tg [-r REMOTE] ($cmds|help) ..."
270         elif [ -r "@cmddir@"/tg-$1 ] ; then
271                 @cmddir@/tg-$1 -h || :
272                 echo
273                 if [ -r "@sharedir@/tg-$1.txt" ] ; then
274                         cat "@sharedir@/tg-$1.txt"
275                 fi
276         else
277                 echo "`basename $0`: no help for $1" 1>&2
278                 do_help
279                 exit 1
280         fi
281 }
282
283 # Check whether we are supposed to output the help message
284 should_do_help()
285 {
286         # we are being sourced for utility functions, never run help
287         [ -z "$tg__include" ] || return 1
288
289         local prev
290         while [ -n "$1" ]; do
291                 case "$1" in
292                 help|--help|-h)
293                         shift
294                         echo "${1:-$prev}"
295                         return 0
296                 esac
297                 prev="$1"
298                 shift
299         done
300
301         # run help when there was no previous topic, meaning that there where
302         # no arguments at all
303         test -z "$prev"
304 }
305
306 ## Pager stuff
307
308 # isatty FD
309 isatty()
310 {
311         test -t $1
312 }
313
314 # setup_pager
315 # Spawn pager process and redirect the rest of our output to it
316 setup_pager()
317 {
318         isatty 1 || return 0
319
320         # TG_PAGER = GIT_PAGER | PAGER | less
321         # NOTE: GIT_PAGER='' is significant
322         TG_PAGER=${GIT_PAGER-${PAGER-less}}
323
324         [ -z "$TG_PAGER"  -o  "$TG_PAGER" = "cat" ]  && return 0
325
326
327         # now spawn pager
328         export LESS=${LESS:-FRSX}       # as in pager.c:pager_preexec()
329
330         _pager_fifo_dir="$(mktemp -t -d tg-pager-fifo.XXXXXX)"
331         _pager_fifo="$_pager_fifo_dir/0"
332         mkfifo -m 600 "$_pager_fifo"
333
334         "$TG_PAGER" < "$_pager_fifo" &
335         exec > "$_pager_fifo"           # dup2(pager_fifo.in, 1)
336
337         # this is needed so e.g. `git diff` will still colorize it's output if
338         # requested in ~/.gitconfig with color.diff=auto
339         export GIT_PAGER_IN_USE=1
340
341         # atexit(close(1); wait pager)
342         trap "exec >&-; rm \"$_pager_fifo\"; rmdir \"$_pager_fifo_dir\"; wait" EXIT
343 }
344
345 ## Startup
346
347 [ -d "@cmddir@" ] ||
348         die "No command directory: '@cmddir@'"
349
350 # check if we should run help and get the topic while we're at it
351 help_topic="$(should_do_help "$@")" && { do_help "$help_topic"; exit 0; }
352
353 ## Initial setup
354
355 set -e
356 git_dir="$(git rev-parse --git-dir)"
357 root_dir="$(git rev-parse --show-cdup)"; root_dir="${root_dir:-.}"
358 # Make sure root_dir doesn't end with a trailing slash.
359 root_dir="${root_dir%/}"
360 base_remote="$(git config topgit.remote 2>/dev/null)" || :
361 tg="tg"
362 # make sure merging the .top* files will always behave sanely
363 setup_ours
364 setup_hook "pre-commit"
365
366 ## Dispatch
367
368 # We were sourced from another script for our utility functions;
369 # this is set by hooks.
370 [ -z "$tg__include" ] || return 0
371
372 if [ "$1" = "-r" ]; then
373         shift
374         if [ -z "$1" ]; then
375                 echo "Option -r requires an argument." >&2
376                 do_help
377                 exit 1
378         fi
379         base_remote="$1"; shift
380         tg="$tg -r $base_remote"
381 fi
382
383 cmd="$1"
384 [ -n "$cmd" ] || { do_help; exit 1; }
385 shift
386
387 case "$cmd" in
388 --hooks-path)
389         # Internal command
390         echo "@hooksdir@";;
391 *)
392         [ -r "@cmddir@"/tg-$cmd ] || {
393                 echo "Unknown subcommand: $cmd" >&2
394                 do_help
395                 exit 1
396         }
397         . "@cmddir@"/tg-$cmd;;
398 esac
399
400 # vim:noet